public morse
public fq

extrn tdid: dword  ; n * 1 ms
extrn spon: word  ; Speaker on 1/0
extrn char: word  ; char (ASCII) wird gesendet
extrn fqindex: word  ; 0= 500hz 20 =1500 hz
extrn muster: word; cw-code
extrn pause: word ; n* tdid nach buchstaben
extrn comx: word ; Basisadresse COMx

code segment byte
assume cs:code

;-----------------------------------------------------
fq proc far             ;tonfrequenz einstellen

;timermode
        mov al,0b6h
        out 43h,al ; modus 3 timer 2

;frequenz        
        mov bx,ds:[fqindex]
        shl bx,1  ; *2

        mov ax,word ptr cs:tontab[bx]
        out 42h,al  ;lsb
        mov al,ah
        out 42h,al  ;msb
        ret

tontab:	dw 2386  ;f=   500
	dw 2169  ;f=   550
	dw 1989  ;f=   600
	dw 1836  ;f=   650
	dw 1705  ;f=   700
	dw 1591  ;f=   750
	dw 1491  ;f=   800
	dw 1404  ;f=   850
	dw 1326  ;f=   900
	dw 1256  ;f=   950
	dw 1193  ;f=  1000
	dw 1136  ;f=  1050
	dw 1085  ;f=  1100
	dw 1038  ;f=  1150
	dw  994  ;f=  1200
	dw  955  ;f=  1250
	dw  918  ;f=  1300
	dw  884  ;f=  1350
	dw  852  ;f=  1400
	dw  823  ;f=  1450
	dw  795  ;f=  1500

fq endp

;--------------------------------------------------------
morse proc far            ; **** HAUPTPROGRAMM ****
        mov ax,ds:[char]  ; ascii-zeichen
        call a2morse      ; ascii -> morse
        call suche_start  ; suche start-bit,erforderlich
                          ; da morsezeichen verschiedene
                          ; laenge haben
        call morse1       ; jetzt wird telegraphiert!!
        ret
morse endp

;------------------------------------------------------
suche_start proc near   ;sucht erstes "1"-bit in muster
;al ist muster
        mov ds:[muster],ax ; ablegen
        mov dl,al          ; muster
        mov dh, 080h       ; anfangs-maske
        mov cx,8           ; max 8 bits testen
l1:
        mov al,dl
        and al,dh
        jnz l2          ;gefunden, bit war "1"
        shr dh,1        ; maske 80,40,20....4,2,1
        dec cl
        jnz l1
l2:
        ret     ; maske steht auf dem bit vor dem
                ; erstem "morse-bit"
suche_start endp        

;---------------------------------------------------
morse1 proc near   ; morse-code ausgeben
                   ; maske wird rechtsgeschoben und 
                   ; getestet,wie zugehoeriges 
                   ; muster-bit aussieht
                   ; 1 : dah
                   ; 0 : did
; al ist anfangs-maske
; muster ist morse-code
        mov cx,ds:[muster]
        mov dl,cl
        mov dh,al     ; maske

        cmp cl,80h
        jnz end_irrung
irrung:
        push dx
        call did
        pop dx
end_irrung:        

        cmp dh,0
        jz wozw       ; wort-zwischenraum
loop_m:
        shr dh,1
        jz f1         ; zeichen zu ende,
                      ; bei muster =0
        push dx
        mov al,dh
        and al,dl
        jz @did       ; muster bit ist 0

        call dah      ; muster bit ist 1
        jmp end1

@did:   call did
end1:   pop dx
        jmp loop_m   ;bis zeichen zu ende

f1:     call tau
        call tau     ;normaler Buchstaben-abstand
        call ntau    ;zusaetzlicher Bu.-abstand
                     ;fuer lernzwecke
        ret

wozw:   call _3tau   ; 3*tau war schon bei 
        call tau     ; ende des letzten buchstabens
        call ntau    ; + uebungsabstand
        ret        
morse1 endp
   
;-----------------------------------------------------
did proc near   ; morse-element "did" inclusiv
                ; element-abstand (eine einheit)
        call ton1       ;ton an und "taste" gedrueckt
        call tau        ;solange
        call ton0       ;ton aus und "taste" losgelassen
        call tau        ;solange
        ret
did endp        

;-----------------------------------------------------
dah proc near   ; morse-element "dah" inclusiv
                ; element-abstand (eine einheit)
        call ton1       ;an
        call _3tau      ;3 zeiteinheiten lang
        call ton0       ;aus
        call tau        ;1 zeiteinheit
        ret
dah endp        

;-----------------------------------------------------
ton1 proc near
        mov dx,ds:[comx]   ;line control register
        cmp dx,0
        je then1
        add dx,3
        mov al,01000000b; break-code =+12v
        out dx,al
then1:        
        mov dx,ds:[spon];speaker on ?
        and dl,dl
        jz spoff

        in al,61h
        or al,3         ;lautsprecher ein
        out 61h,al
        ret

spoff:  in al,61h
        and al,not 3    ;lautsprecher aus
        out 61h,al
        ret
ton1 endp

;-----------------------------------------------------
ton0 proc near
        mov dx,ds:[comx]   ;line control register
        cmp dx,0
        je then2
        add dx,3
        mov al,0        ;ruhelage= -12v
        out dx,al
then2:        
        in al,61h
        and al,not 3    ;lautsprecher aus
        out 61h,al
        ret
ton0 endp


;-----------------------------------------------------
tau proc near   ; kleinste zeiteinheit fuer
                ; morsezeichen
        mov cx,ds: word ptr [tdid+2] ; high (usec)
        mov dx,ds: word ptr [tdid]   ; low  (usec)
        mov ah,86h      ; cx:dx usec warten
        int 15h         ; dos zeitfunktion
        ret
tau endp


;-----------------------------------------------------
_3tau proc near         ; 3 zeiteinheiten
         call tau
         call tau
         call tau
         ret
_3tau endp

;-----------------------------------------------------
ntau proc near  ; n zeiteinheiten, wird hier nur
                ; gebraucht, um fuer uebungszwecke
                ; nach einem buchstaben eine zusaetzliche
                ; pause einzufuegen
        mov cx,ds:[pause]       ; faktor
        and cl,cl
ntau1:  jz ntau2
        push cx
        call tau        ; eine zeiteinheit
        pop cx
        dec cl          ; zaehlwert
        jnz ntau1
ntau2:  ret
ntau endp


;-------------------------------------------------------
a2morse proc near

             ; umwandlung "ascii to morse" ueber tabelle
             ; z.b.  'a'  =00000101b
             ;                  ^._
             
             ;       '2'  =00100111b
             ;               ^..___
             ; bei "^" hinter dem ersten 1-bit 
             ; faengt der morse-code an

        mov bx,offset morse_tabelle
        xlat cs:[bx]
        ret
 
morse_tabelle:

x00:
 db  1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 
 db  1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 
x10:
 db  1 , 1 , 1 , 1 , 1 , 1 , 1 ,28h
 db  1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 
x20:
 db 00h,80h,52h,45h,1fh, 1 ,28h,5eh
 db 36h,6dh,35h,2Ah,73h,61h,55h,32h
x30:
 db 3Fh,2Fh,27h,23h,21h,20h,30h,38h
 db 3Ch,3Eh,78h,6ah, 1 ,31h, 1 ,4Ch
x40:
 db  1 ,05h,18h,1Ah,0Ch,02h,12h,0Eh
 db 10h,04h,17h,0Dh,14h,07h,06h,0Fh
x50:
 db 16h,1Dh,0Ah,08h,03h,09h,11h,0Bh
 db 19h,1Bh,1Ch, 1 , 1 , 1 , 1 , 1 
x60:
 db  1 ,05h,18h,1Ah,0Ch,02h,12h,0Eh
 db 10h,04h,17h,0Dh,14h,07h,06h,0Fh
x70:
 db 16h,1Dh,0Ah,08h,03h,09h,11h,0Bh
 db 19h,1Bh,1Ch, 1 , 1 , 1 , 1 , 1 
x80:
 db  1 ,13h, 1 , 1 ,15h, 1 , 1 , 1 
 db  1 , 1 , 1 , 1 , 1 , 1 ,15h, 1   
x90:
 db  1 , 1 , 1 , 1 ,1eh, 1 , 1 , 1 
 db  1 ,1eh,13h, 1 , 1 , 1 , 1 , 1   

a2morse endp
;-----------------------------------------------------

code ends

end
